#!/bin/sh
# --- SDE-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# Filename: src/tools-source/versionsort.sh
# Copyright (C) 2009 The OpenSDE Project
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- SDE-COPYRIGHT-NOTE-END ---


versionsort_c=${0%/*}/versionsort.c
versionsort="${versionsort_c%.c}"

if [ "$versionsort_c" -nt "$versionsort" ]; then
	gcc -o "$versionsort" -O0 -g -W -Wall "$versionsort_c" || exit $?
fi

try() {
	local data= expected="$*" got=

	data="$(echo "$@" | tr ' ' '\n' | shuf | tr '\n' ' ' | sed -e 's, \+$,,')"
	got=$("$versionsort" $data | tr '\n' ' ' | sed -e 's, \+$,,')
	if [ "$got" = "$expected" ]; then
		echo "OK: '$data' ($expected)"
	else
		echo "FAILED: '$data' ('$got' != '$expected')" >&2
	fi
}

# give the list in the expected order
try 1 2
try 1.1 1.2
try 2.6.9 2.6.19 2.6.28.7
